#ifndef MSP_DATAFILE_BINARYPARSER_H_
#define MSP_DATAFILE_BINARYPARSER_H_

#include <map>
#include "binarydict.h"
#include "parsermode.h"
#include "type.h"

namespace Msp {
namespace DataFile {

/**
Parses data in binary format.
*/
class BinaryParser: public ParserMode
{
private:
	typedef std::map<int, DictEntry> Dictionary;
	typedef std::map<unsigned, std::string> StringMap;

	Dictionary dict;
	StringMap strings;
	bool first;
	unsigned float_precision;

public:
	BinaryParser(Input &i, const std::string &s);

	virtual Statement parse(bool);
private:
	Statement parse_statement(bool);
	IntType::Store parse_int();
	FloatType::Store parse_float();
	StringType::Store parse_string();
	BoolType::Store parse_bool();
	SymbolType::Store parse_symbol();
};

} // namespace DataFile
} // namespace Msp

#endif
